import _construct from "@babel/runtime/helpers/esm/construct";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import { Phases, symbol } from './constants';
import { initDomain } from 'resolve-core';
export var executeReadModel = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee5(_ref) {
    var promise, createQuery, transformEvents, detectConnectorFeatures, connectorModes, queryExecutor, performAcknowledge, acknowledgePromise, provideLedger, secretsManager, domain, eventstoreAdapter, isInlineLedger, errors, status, error, _yield$acknowledgePro, projectionError, _error, result, _yield$queryExecutor$, _error2;

    return _regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            promise = _ref.promise, createQuery = _ref.createQuery, transformEvents = _ref.transformEvents, detectConnectorFeatures = _ref.detectConnectorFeatures, connectorModes = _ref.connectorModes;

            if (!(promise[symbol].phase < Phases.RESOLVER)) {
              _context5.next = 3;
              break;
            }

            throw new TypeError(promise[symbol].phase);

          case 3:
            queryExecutor = null;
            performAcknowledge = null;
            acknowledgePromise = new Promise(function (resolve) {
              performAcknowledge = /*#__PURE__*/function () {
                var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(result) {
                  return _regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          _context.next = 2;
                          return resolve(result);

                        case 2:
                          return _context.abrupt("return", _context.sent);

                        case 3:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee);
                }));

                return function performAcknowledge(_x2) {
                  return _ref3.apply(this, arguments);
                };
              }();
            });

            provideLedger = /*#__PURE__*/function () {
              var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(ledger) {
                return _regeneratorRuntime.wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        return _context2.abrupt("return", void 0);

                      case 1:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2);
              }));

              return function provideLedger(_x3) {
                return _ref4.apply(this, arguments);
              };
            }();

            secretsManager = promise[symbol].secretsManager;
            domain = initDomain({
              viewModels: [],
              readModels: [{
                name: promise[symbol].name,
                projection: promise[symbol].projection,
                resolvers: promise[symbol].resolvers,
                connectorName: 'ADAPTER_NAME',
                encryption: promise[symbol].encryption
              }],
              aggregates: [],
              sagas: []
            });
            _context5.prev = 9;
            eventstoreAdapter = {
              getSecretsManager: function getSecretsManager() {
                return promise[symbol].secretsManager;
              },
              loadEvents: function () {
                var _loadEvents = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3() {
                  return _regeneratorRuntime.wrap(function _callee3$(_context3) {
                    while (1) {
                      switch (_context3.prev = _context3.next) {
                        case 0:
                          _context3.t0 = transformEvents(promise[symbol].events);
                          return _context3.abrupt("return", {
                            events: _context3.t0,

                            get cursor() {
                              throw new Error('Cursor should not be accessed from resolve-testing-tools');
                            }

                          });

                        case 2:
                        case "end":
                          return _context3.stop();
                      }
                    }
                  }, _callee3);
                }));

                function loadEvents() {
                  return _loadEvents.apply(this, arguments);
                }

                return loadEvents;
              }(),
              getNextCursor: function getNextCursor() {
                return 'SHIFT_CURSOR';
              }
            };
            queryExecutor = createQuery({
              readModelConnectors: {
                ADAPTER_NAME: promise[symbol].adapter
              },
              getVacantTimeInMillis: function getVacantTimeInMillis() {
                return 0x7fffffff;
              },
              invokeEventBusAsync: function () {
                var _invokeEventBusAsync = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4() {
                  return _regeneratorRuntime.wrap(function _callee4$(_context4) {
                    while (1) {
                      switch (_context4.prev = _context4.next) {
                        case 0:
                          return _context4.abrupt("return", void 0);

                        case 1:
                        case "end":
                          return _context4.stop();
                      }
                    }
                  }, _callee4);
                }));

                function invokeEventBusAsync() {
                  return _invokeEventBusAsync.apply(this, arguments);
                }

                return invokeEventBusAsync;
              }(),
              eventstoreAdapter: eventstoreAdapter,
              performAcknowledge: performAcknowledge,
              readModelsInterop: domain.readModelDomain.acquireReadModelsInterop({
                secretsManager: secretsManager,
                monitoring: {}
              }),
              viewModelsInterop: {},
              performanceTracer: null,
              provideLedger: provideLedger
            });
            _context5.next = 14;
            return detectConnectorFeatures(promise[symbol].adapter);

          case 14:
            _context5.t0 = _context5.sent;
            _context5.t1 = connectorModes.INLINE_LEDGER_CONNECTOR;
            isInlineLedger = _context5.t0 === _context5.t1;
            errors = [];
            _context5.prev = 18;

            if (!isInlineLedger) {
              _context5.next = 35;
              break;
            }

            _context5.next = 22;
            return queryExecutor.subscribe({
              modelName: promise[symbol].name,
              subscriptionOptions: {
                eventTypes: null,
                aggregateIds: null
              }
            });

          case 22:
            _context5.next = 24;
            return queryExecutor.build({
              modelName: promise[symbol].name
            });

          case 24:
            _context5.next = 26;
            return queryExecutor.build({
              modelName: promise[symbol].name
            });

          case 26:
            _context5.next = 28;
            return queryExecutor.status({
              modelName: promise[symbol].name
            });

          case 28:
            status = _context5.sent;

            if (!(status.status === 'error')) {
              _context5.next = 33;
              break;
            }

            error = _construct(Error, Array.isArray(status.errors) ? [status.errors.map(function (err) {
              return err.message;
            }).join('\n')] : []);
            error.stack = Array.isArray(status.errors) ? status.errors.map(function (err) {
              return err.stack;
            }).join('\n') : error.stack;
            throw error;

          case 33:
            _context5.next = 47;
            break;

          case 35:
            _context5.next = 37;
            return queryExecutor.sendEvents({
              modelName: promise[symbol].name,
              events: [{
                type: 'Init'
              }]
            });

          case 37:
            _context5.next = 39;
            return queryExecutor.sendEvents({
              modelName: promise[symbol].name,
              events: transformEvents(promise[symbol].events)
            });

          case 39:
            _context5.next = 41;
            return acknowledgePromise;

          case 41:
            _yield$acknowledgePro = _context5.sent;
            projectionError = _yield$acknowledgePro.result.error;

            if (!(projectionError != null)) {
              _context5.next = 47;
              break;
            }

            _error = new Error(projectionError.message);
            _error.stack = projectionError.stack;
            throw _error;

          case 47:
            _context5.next = 52;
            break;

          case 49:
            _context5.prev = 49;
            _context5.t2 = _context5["catch"](18);
            errors.push(_context5.t2);

          case 52:
            result = null;
            _context5.prev = 53;
            _context5.next = 56;
            return queryExecutor.read({
              modelName: promise[symbol].name,
              resolverName: promise[symbol].resolverName,
              resolverArgs: promise[symbol].resolverArgs,
              jwt: promise[symbol].jwt
            });

          case 56:
            _yield$queryExecutor$ = _context5.sent;
            result = _yield$queryExecutor$.data;
            void _yield$queryExecutor$;
            _context5.next = 64;
            break;

          case 61:
            _context5.prev = 61;
            _context5.t3 = _context5["catch"](53);
            errors.push(_context5.t3);

          case 64:
            _context5.prev = 64;

            if (!isInlineLedger) {
              _context5.next = 70;
              break;
            }

            _context5.next = 68;
            return queryExecutor.unsubscribe({
              modelName: promise[symbol].name
            });

          case 68:
            _context5.next = 72;
            break;

          case 70:
            _context5.next = 72;
            return queryExecutor.drop({
              modelName: promise[symbol].name
            });

          case 72:
            _context5.next = 77;
            break;

          case 74:
            _context5.prev = 74;
            _context5.t4 = _context5["catch"](64);
            errors.push(_context5.t4);

          case 77:
            if (!(errors.length > 0)) {
              _context5.next = 81;
              break;
            }

            _error2 = new Error(errors.map(function (err) {
              return err.message;
            }).join('\n'));
            _error2.stack = errors.map(function (err) {
              return err.stack;
            }).join('\n');
            throw _error2;

          case 81:
            promise[symbol].resolve(result);
            _context5.next = 87;
            break;

          case 84:
            _context5.prev = 84;
            _context5.t5 = _context5["catch"](9);
            promise[symbol].reject(_context5.t5);

          case 87:
            _context5.prev = 87;

            if (!(queryExecutor != null)) {
              _context5.next = 91;
              break;
            }

            _context5.next = 91;
            return queryExecutor.dispose();

          case 91:
            return _context5.finish(87);

          case 92:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5, null, [[9, 84, 87, 92], [18, 49], [53, 61], [64, 74]]);
  }));

  return function executeReadModel(_x) {
    return _ref2.apply(this, arguments);
  };
}();
//# sourceMappingURL=execute-read-model.js.map